import Flutter
import UIKit

public class SwiftFlutterIoshttpPlugin: NSObject, FlutterPlugin {
  public static func register(with registrar: FlutterPluginRegistrar) {
    let channel = FlutterMethodChannel(name: "flutter_ioshttp", binaryMessenger: registrar.messenger())
    let instance = SwiftFlutterIoshttpPlugin()
    registrar.addMethodCallDelegate(instance, channel: channel)
  }

  public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
    print(call.method)
    if (call.method == "getPlatformVersion") {
        result("iOS " + UIDevice.current.systemVersion)
    }
    if (call.method == "httpGet") {
        print("calling httpGet")
        let args = call.arguments as? [String];
        let url = args![0] as String;
        let request = URLRequest(url: NSURL(string: url)! as URL)
        do {
            let response: AutoreleasingUnsafeMutablePointer<URLResponse?>? = nil;
            let data = try NSURLConnection.sendSynchronousRequest(request, returning: response)
            
            let jsonSerialized = try JSONSerialization.jsonObject(with: data, options: []) 
            print(jsonSerialized)
            result(jsonSerialized)
        } catch {
            print("httpPost Failed")
        }
    }
    if (call.method == "httpPost") {
        let args = call.arguments as? [Any];
        let url = args![0] as! String;
        let body = args![1] as! NSDictionary;
        do {
            let jsonBody = try JSONSerialization.data(withJSONObject: body, options: [])
            var request = URLRequest(url: NSURL(string: url)! as URL)
            request.httpBody = jsonBody
            let response: AutoreleasingUnsafeMutablePointer<URLResponse?>? = nil;
            let data = try NSURLConnection.sendSynchronousRequest(request, returning: response)
            
            let jsonSerialized = try JSONSerialization.jsonObject(with: data, options: []) as? [String : Any]
            
            result(jsonSerialized)
        } catch {
            print("httpPost Failed")
        }
    }
  }
}
